$MultitoolMode[$MultitoolTotal] = "PrintFill";

$MultitoolTotal++;

$MaxPrintFillBricks = 200;


package PrintFill

{

	function serverCmdSetPrint(%Client,%Print)

	{

		if(!%Client.isFillPrinting){parent::serverCmdSetPrint(%Client,%Print);}

		else{setPrint(%Client,%Print,%Client.PrintBrick);}

	}



	function PrintFill(%this,%obj,%col,%fade,%pos,%normal)

	{

		%Client = %obj.client;

		%Client.isFillPrinting = 1;

		%ar = %col.printAspectRatio;

		%Client.printBrick = %col;

		%Client.FillPrintingDone = 0;

		commandToClient(%Client,'openPrintSelectorDlg',%ar,$printARStart[%ar], $printARNumPrints[%ar]);
	}



	function PrintFillClean(%Client)

	{

		for(%i=0;%i<%Client.PrintFillCnt;%i++){%Client.PrintFillBrick[%i] = 0;}

		%Client.PrintFillCnt = 0;

		%Client.isFillPrinting = 0;

		%Client.FillPrintingDone = 1;

	}



	function setPrint(%Client,%Print,%Col)

	{

		if(getTrustLevel(%col,%Client) < $TrustLevel::Print)

		{

			CommandToClient(%Client,'CenterPrint',%Col.getGroup().name @ " does not trust you enough to do that.", 1);

			return;

		}

		if(!%Client.PrintFillCnt)

		{

			%Client.PrintFillBrick[0] = %col;

			%Client.PrintFillCnt = 1;

			parent::serverCmdSetPrint(%Client,%Print);

		}

		%colData = %col.getDataBlock();

		%rot = round(getword(%col.rotation,3));

		if(%rot==90){%area = (%colData.bricksizey*0.55) SPC (%colData.bricksizex*0.55) SPC (%colData.bricksizez*0.25);}

		else{%area = (%colData.bricksizex*0.55) SPC (%colData.bricksizey*0.55) SPC (%colData.bricksizez*0.25);}

		InitContainerBoxSearch(%col.getposition(),%area,$typemasks::fxbrickobjecttype);

		while((%brick = ContainerSearchNext()) >= 0 && !%Client.FillPrintingDone)

		{

			if(isEventPending(%Client.PrintFillEvnt)){cancel(%Client.PrintFillEvnt);}

			if(%brick == 0){%Client.PrintFillEvnt = schedule(500,0,"PrintFillClean",%Client);break;}

			if(%Client.PrintFillCnt < $MaxPrintFillBricks)

			{

				if(%brick.getDataBlock().printAspectRatio && %Brick !$= %Col && %brick.isPlanted() && %Brick.printID !$= %Print)

				{

					%Client.PrintBrick = %brick;

					%Client.PrintFillBrick[%Client.PrintFillCnt] = %brick;

					%Client.PrintFillCnt++;

					parent::serverCmdSetPrint(%Client,%Print);

					schedule(150,0,"SetPrint",%Client,%Print,%Brick);

				}

			}

			else{schedule(1000,0,"PrintFillClean",%Client);}

		}

	}

};

ActivatePackage(PrintFill);


